// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package sanitizer

import (
	"testing"

	"github.com/google/go-cmp/cmp"
)

func TestSanitize(t *testing.T) {
	testCases := []struct {
		name  string
		input string
		want  string
	}{{
		name:  "quotes strings",
		input: "test",
		want:  "\"test\"",
	}}

	for _, test := range testCases {
		t.Run(test.name, func(t *testing.T) {
			got := sanitize(test.input)
			if diff := cmp.Diff(test.want, got); diff != "" {
				t.Errorf("Sanitize (-want, +got) = %v", diff)
			}
		})
	}

}
