// Copyright 2020 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/google/kf/v2/pkg/apis/kf/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TaskScheduleLister helps list TaskSchedules.
// All objects returned here must be treated as read-only.
type TaskScheduleLister interface {
	// List lists all TaskSchedules in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.TaskSchedule, err error)
	// TaskSchedules returns an object that can list and get TaskSchedules.
	TaskSchedules(namespace string) TaskScheduleNamespaceLister
	TaskScheduleListerExpansion
}

// taskScheduleLister implements the TaskScheduleLister interface.
type taskScheduleLister struct {
	indexer cache.Indexer
}

// NewTaskScheduleLister returns a new TaskScheduleLister.
func NewTaskScheduleLister(indexer cache.Indexer) TaskScheduleLister {
	return &taskScheduleLister{indexer: indexer}
}

// List lists all TaskSchedules in the indexer.
func (s *taskScheduleLister) List(selector labels.Selector) (ret []*v1alpha1.TaskSchedule, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.TaskSchedule))
	})
	return ret, err
}

// TaskSchedules returns an object that can list and get TaskSchedules.
func (s *taskScheduleLister) TaskSchedules(namespace string) TaskScheduleNamespaceLister {
	return taskScheduleNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// TaskScheduleNamespaceLister helps list and get TaskSchedules.
// All objects returned here must be treated as read-only.
type TaskScheduleNamespaceLister interface {
	// List lists all TaskSchedules in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.TaskSchedule, err error)
	// Get retrieves the TaskSchedule from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.TaskSchedule, error)
	TaskScheduleNamespaceListerExpansion
}

// taskScheduleNamespaceLister implements the TaskScheduleNamespaceLister
// interface.
type taskScheduleNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all TaskSchedules in the indexer for a given namespace.
func (s taskScheduleNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.TaskSchedule, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.TaskSchedule))
	})
	return ret, err
}

// Get retrieves the TaskSchedule from the indexer for a given namespace and name.
func (s taskScheduleNamespaceLister) Get(name string) (*v1alpha1.TaskSchedule, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("taskschedule"), name)
	}
	return obj.(*v1alpha1.TaskSchedule), nil
}
