// Copyright 2020 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// Code generated by MockGen. DO NOT EDIT.
// Source: github.com/google/kf/v2/pkg/kf/apps/fake (interfaces: Pusher)

// Package fake is a generated GoMock package.
package fake

import (
	context "context"
	reflect "reflect"

	gomock "github.com/golang/mock/gomock"
	v1alpha1 "github.com/google/kf/v2/pkg/apis/kf/v1alpha1"
	apps "github.com/google/kf/v2/pkg/kf/apps"
)

// FakePusher is a mock of Pusher interface.
type FakePusher struct {
	ctrl     *gomock.Controller
	recorder *FakePusherMockRecorder
}

// FakePusherMockRecorder is the mock recorder for FakePusher.
type FakePusherMockRecorder struct {
	mock *FakePusher
}

// NewFakePusher creates a new mock instance.
func NewFakePusher(ctrl *gomock.Controller) *FakePusher {
	mock := &FakePusher{ctrl: ctrl}
	mock.recorder = &FakePusherMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *FakePusher) EXPECT() *FakePusherMockRecorder {
	return m.recorder
}

// CreatePlaceholderApp mocks base method.
func (m *FakePusher) CreatePlaceholderApp(arg0 context.Context, arg1 string, arg2 ...apps.PushOption) (*v1alpha1.App, error) {
	m.ctrl.T.Helper()
	varargs := []interface{}{arg0, arg1}
	for _, a := range arg2 {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "CreatePlaceholderApp", varargs...)
	ret0, _ := ret[0].(*v1alpha1.App)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// CreatePlaceholderApp indicates an expected call of CreatePlaceholderApp.
func (mr *FakePusherMockRecorder) CreatePlaceholderApp(arg0, arg1 interface{}, arg2 ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{arg0, arg1}, arg2...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CreatePlaceholderApp", reflect.TypeOf((*FakePusher)(nil).CreatePlaceholderApp), varargs...)
}

// Push mocks base method.
func (m *FakePusher) Push(arg0 context.Context, arg1 string, arg2 ...apps.PushOption) error {
	m.ctrl.T.Helper()
	varargs := []interface{}{arg0, arg1}
	for _, a := range arg2 {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "Push", varargs...)
	ret0, _ := ret[0].(error)
	return ret0
}

// Push indicates an expected call of Push.
func (mr *FakePusherMockRecorder) Push(arg0, arg1 interface{}, arg2 ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{arg0, arg1}, arg2...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Push", reflect.TypeOf((*FakePusher)(nil).Push), varargs...)
}
